<%@page import="java.util.Enumeration"%>
<% /* 
    * Licensed Materials - Property of IBM
    *
    * IBM Enterprise Transformation for IBM i - WebFacing
    *
    *  Copyright IBM Corp. 2009 All Rights Reserved
    *
    * US Government Users Restricted Rights - Use, duplication or
    * disclosure restricted by GSA ADP Schedule Contract with
    * IBM Corp.
    */ %>
<jsp:useBean id="wfcmdkeys" scope="request" class="com.ibm.as400ad.webfacing.runtime.dhtmlview.CmdKeysBean" type="com.ibm.as400ad.webfacing.runtime.dhtmlview.ICmdKeysInterface"/>
<%	
 /*
  * You can specify the amount of space that will be allocated for each key and the count of keys that will
  *	be placed horizontally together.  A count of 1 means a vertical stack.
  *
  *		bHeight=nnn  	 (height of each "key" specified in pixels)
  *		bWidth=nnn   	 (width of each "key" specified in pixels)
  *		bCount=nn    	 (number of keys that should be placed together horizontally)
  *		bTitle=true/false (should the keys have fly-over title)
  */

  String bHeight="18";
  String bWidth="145";
  int bCount=1;
  boolean bTitle=true;

  // Is this an application area key?
  boolean isInAppArea = (null != request.getAttribute("caller"));
  
  //if (isInAppArea)
  {
    // Override defaults for style from request attributes for app area keys
    if(null != request.getAttribute("height"))
    {
       bHeight =(String)request.getAttribute("height");
    } 
    if(null != request.getAttribute("width"))
    {
       bWidth = (String)request.getAttribute("width");
    }   
    if(null != request.getAttribute("count"))
    {
       bCount = Integer.parseInt((String)request.getAttribute("count"));
    }
    if (null != request.getAttribute("title"))
    {
      String title = (String)request.getAttribute("title");
      if(title.equalsIgnoreCase("false") || title.equalsIgnoreCase("no"))
      {
	    bTitle = false;
	  }
    }
  }
  
  // Initialize the Command Keys Bean
  wfcmdkeys.init((String)request.getAttribute("cmdkeylist"),
  			bWidth, bHeight, bCount, (String)request.getAttribute("fieldname"),
  			bTitle, isInAppArea, getServletContext(), session);
  
  // Clean up request attributes
  request.removeAttribute("height");
  request.removeAttribute("width");
  request.removeAttribute("count");
  request.removeAttribute("title");
  request.removeAttribute("cmdkeylist");
  request.removeAttribute("fieldname");
  			
  com.ibm.as400ad.webfacing.runtime.view.IClientAIDKey fkey = null;
  java.util.Iterator functionKeys = wfcmdkeys.getPageOrFieldKeyList();




  // Loop through and add Page or Field Scope Command Key Buttons
  while ( (functionKeys != null) && (true == functionKeys.hasNext()) )
  {
        
    while (functionKeys.hasNext()) 
    { 
      fkey = (com.ibm.as400ad.webfacing.runtime.view.IClientAIDKey) functionKeys.next();
      if (true == fkey.isKeyShownOnClient())
      {	
        String keyName = fkey.getKeyName();
        String idn = wfcmdkeys.getKeyUniqueId() + keyName;
        String label = fkey.getOverridingLabel();
        String ovrideClick="", ovrideURI="", ovrideFrame="";
        boolean completeOverride = false;

        if ( true == fkey.isOverriden() ) 
        {
          ovrideURI = fkey.getOverridingURI();
          ovrideFrame = fkey.getOverridingTargetFrame();
          if (ovrideURI.startsWith("javascript"))
          {
            ovrideClick = ovrideURI + ";";
            completeOverride = true;
          }
          else
          {
            ovrideClick = wfcmdkeys.getJsVersionedPrefix() + "setOvrInfo('" + ovrideURI + "','" + ovrideFrame + "','" + wfcmdkeys.getUniqueId() + "');";
          }
        }
        else 
        {
          // if the overriding label is blank then get the key label
          if (true ==label.equals(""))
          {
            label = fkey.getKeyLabel();
          }
        } 
               		
        // If the key name is to be shown change it from "label" ot
        // "Fnn=label" so that the function key name is obvious  		
        if ( (true == wfcmdkeys.isKeyNameShown()) && (false == keyName.equalsIgnoreCase(label))&& fkey.isCommandKey() )
        {
          label = fkey.transformFKeyName(keyName) + "=" + label;
        }	

		// should the keys have fly-over title
		String titleString = "";
		if (true == wfcmdkeys.isFlyOverShown()) {
			titleString = " title=\"" + keyName + "\"";
		}

         /*
          *  At this point the key is fully resolved.  You could
          *  place code here to skip over the the issuing of the
          *  key or modify or replace the key dynamically before
          *  emitting the key's html to the browser.
          */
        if (true == completeOverride)
        {
          %><li><a href="javascript:<%=wfcmdkeys.getJsVersionedPrefix()%>bd_ibm(this, 'buttondown');<%= ovrideClick %>"><%= fkey.transformFKeyName(label) %></a></li><script language='JavaScript'><%=wfcmdkeys.getJsVersionedPrefix()%>regCmdKey('<%= idn%>', '<%= keyName %>', '<%= ovrideURI %>','<%= ovrideFrame %>','<%=wfcmdkeys.getUniqueId()%>');</script>
          <%
        }
        else
        {
          %><li><a href="javascript:<%=wfcmdkeys.getJsVersionedPrefix()%>bd_ibm(this, 'buttondown');<%= ovrideClick %><%=wfcmdkeys.getJsVersionedPrefix()%>validateAndSubmit('<%= keyName %>','<%=wfcmdkeys.getUniqueId()%>');"><%= fkey.transformFKeyName(label) %></a></li><script language='JavaScript'><%=wfcmdkeys.getJsVersionedPrefix()%>regCmdKey('<%= idn%>', '<%= keyName %>', '<%= ovrideURI %>','<%= ovrideFrame %>','<%=wfcmdkeys.getUniqueId()%>');</script>
          <%
        }
      }
    }
  }
		
%>