dojo.provide("bididijit.ComboBoxBidi");

dojo.require("dijit.form.ComboBox");
dojo.require("bididijit.TextBoxBidi");

var LRO = String.fromCharCode(8237);
var RLO = String.fromCharCode(8238);

dojo.declare(
	"bididijit.ComboBoxBidi",
	[bididijit.TextBoxBidi, dijit.form.ComboBoxMixin],
	{
	
        postCreate: function(){        	        	
            if(this.isVisualMode) {		
	            var options = this.srcNodeRef;
	            for (var k = 0; k < options.length; k++) {
	                if(options[k].tagName == "OPTION") {
	                    var text = (dojo.isIE) ? options[k].innerText : options[k].textContent;
	                    if (this.dir == "rtl")
	                    	text = this.reverseText(text);

	                    if(dojo.isIE)
	                    	options[k].innerText = ((this.dir == "rtl") ? RLO : LRO) + text;
	                    else
	                    	options[k].textContent = text;
	                }
	            }	            
            } 
            if (!dojo.isIE) {
            	var selector = "#" + this.id + "_popup li.dijitReset.dijitMenuItem";
               	var ss = document.styleSheets[0];
               	var qRules = ss.cssRules.length;
               	var pos = -1;
               	for (var i=ss.cssRules.length-1; i>=0; i--) {
               		if (ss.cssRules[i].selectorText && ss.cssRules[i].selectorText.toLowerCase().indexOf(selector.toLowerCase()) >=0) {
               		   pos = i;
               		   break;
               		}	
               	}
               	var bidiStyle = (this.dir == "rtl") ? " {text-align: right; direction: rtl; unicode-bidi: bidi-override;}" : " {unicode-bidi: bidi-override;}";	
               	if (this.isVisualMode && pos < 0)
               	   ss.insertRule(selector + bidiStyle,qRules);
               	else if(!this.isVisualMode && pos >=0)
               	   ss.deleteRule(pos);
            }	                
            this.inherited(arguments);                 
        },

        _onKeyPress: function(evt) {
           dijit.form.ComboBoxMixin.prototype._onKeyPress.call(this,evt);

           if (evt.charOrCode == dojo.keys.ENTER)
               this.processComboSelection(evt);	
           else 
        	   dojo.hitch(this, "_onKeyPressBidi"); 
        },
        	                	      	        
	displayMessage: function(message) {
        },

        validate: function(isFocused){
        	return true;
        },
        
        _selectOption: function(/*Event*/ evt){
        	this.inherited(arguments);
        	this.processComboSelection(evt);
        },
        
        processComboSelection: function(evt) {
        	if(this.isVisualMode && dojo.isIE) { 
            	this._onFocus(evt);        		
				var selection = this.getCaretPos(evt,this.focusNode);
				if (selection) {
				    selectionStart = Math.min(selection[0],selection[1]);
				    curPos = Math.max(selection[0],selection[1]);
				}
				this.setCaretPositions(selectionStart, curPos);
        	}        	
        }
});
