var navIsIE = false;

function hasClass(ele,cls) {
	return ele.className.match(new RegExp('(\\s|^)'+cls+'(\\s|$)'));
}

function navHoverIn(ele) {
	var activeElem = document.getElementById('lvl1nav_activeitem');
	activeElem.getElementsByTagName("ul")[0].style.display = "none";
	ele.className = ele.className.replace("lvl1nav_item_hover","");
	ele.className = ele.className + " lvl1nav_item_hover";
	ele.getElementsByTagName("ul")[0].style.display = "block";
	if (navIsIE){
		ele.getElementsByTagName("ul")[0].style.width = document.getElementById("wrapper").clientWidth + "px";
	}
}

function navHoverOut(ele){
	ele.getElementsByTagName("ul")[0].style.display = "none";
	ele.className = ele.className.replace("lvl1nav_item_hover","");
	var activeElem = document.getElementById('lvl1nav_activeitem');
	activeElem.getElementsByTagName("ul")[0].style.display = "block";
}

function navClickIn(ele){
	var activeElem = document.getElementById('lvl1nav_activeitem');
	activeElem.getElementsByTagName("ul")[0].style.display = "none";
	activeElem.id = activeElem.id.replace("lvl1nav_activeitem","");
	
	ele.id = "lvl1nav_activeitem";
	ele.getElementsByTagName("ul")[0].style.display = "block";

	if (navIsIE){
		ele.getElementsByTagName("ul")[0].style.width = document.getElementById("wrapper").clientWidth + "px";		
	}
}

function initNavJS() {
	if (navigator.appName =="Microsoft Internet Explorer"){
		navIsIE = true;
	}
	
	var eles=document.getElementsByTagName("*");

	for (var i=0; i<eles.length; i++) {
		if (hasClass(eles[i],'lvl1nav_item')) {
			eles[i].getElementsByTagName("a")[0].onfocus = eles[i].getElementsByTagName("a")[0].onclick = function() { navClickIn(this.parentNode); } ;
			if(navIsIE){
				eles[i].onmouseenter = function() { navHoverIn(this); } ;
				eles[i].onmouseleave = function() { navHoverOut(this); } ;		
			}
			else {
				eles[i].onmouseover = function() { navHoverIn(this); } ;
				eles[i].onmouseout = function() { navHoverOut(this); } ;
			}
		}
		if (eles[i].id=='lvl1nav_activeitem'){
			var ele = eles[i];
			ele.getElementsByTagName("ul")[0].style.display = "block";
			if (navIsIE){
				ele.getElementsByTagName("ul")[0].style.width = document.getElementById("wrapper").clientWidth + "px";	
			}		
		}
	}
}

var currentWindowOnload = window.onload || function () {};
window.onload = null;
window.onload = function () { currentWindowOnload(); initNavJS(); };
